<script type="text/html" data-template-name="whitelists">
  <div class="form-row">
    <label for="node-input-name"><i class="fa fa-tag"></i> <span data-i18n="name"></span></label>
    <input type="text" id="node-input-name" data-i18n="[placeholder]name">
  </div>
  <div class="form-row node-input-property-container-row">
    <label for="node-input-property-container"><i class="fa fa-tag"></i> <span data-i18n="list"></span></label>
    <ol id="node-input-property-container"></ol>
  </div>
</script>

<script type="text/javascript">
  function resizeDialog(size) {
      size = size || { height: $(".red-ui-tray-content form").height() }
      var rows = $("#dialog-form>div:not(.node-input-property-container-row):visible");
      var height = size.height;
      for (var i = 0; i < rows.length; i++) {
          height -= $(rows[i]).outerHeight(true);
      }
      var editorRow = $("#dialog-form>div.node-input-property-container-row");
      height -= (parseInt(editorRow.css("marginTop")) + parseInt(editorRow.css("marginBottom")));
      height += 16;
      $("#node-input-property-container").editableList('height',height);
  }

  RED.nodes.registerType('whitelists',{
      category: 'nilvana',
      color: '#A6ABF8',
      defaults: {
          name: {value: ""},
          list: {value: []}
      },
      inputs:1,
      outputs:1,
      icon: "icons/white-list.png",
      label: function() {
          return this.name || "whitelists";
      },
      oneditresize: resizeDialog,
      oneditprepare: function () {
        const containerElement = $('#node-input-property-container');
        containerElement
          .css('min-height','150px')
          .css('min-width','450px')
          .css('max-height', '500px')
          .editableList({
            addItem: function(container, i, prop) {
              if (!prop.hasOwnProperty('name')) {
                  prop = {name: ""};
              }
              container.css({
                  overflow: 'hidden',
                  whiteSpace: 'nowrap'
              });
              var row = $('<div/>').appendTo(container);

              var propertyName = $('<input/>',{class:"node-input-prop-property-name",type:"text"})
                  .css("width","98%")
                  .appendTo(row)
                  .typedInput({types:['str']});
              propertyName.typedInput('value',prop.name);
            },
            removable: true,
            sortable: true
        });

        if(this.list.length === 0) {
          containerElement.editableList('addItem',{ name: ''});
        }

        this.list.forEach(prop => {
          containerElement.editableList('addItem',{ name: prop.name});
        })
      },
      oneditsave: function () {
        let props = $("#node-input-property-container").editableList('items');
        node = this;
        node.list = [];
        props.each(function(index) {
          var prop = $(this);
          node.list.push({
            name: prop.find(".node-input-prop-property-name").typedInput('value')
          });
        })
      }
  });
</script>